/* flip_graffiti.c */

#include <Pilot.h>
#include "FlipHack.h"

#include "flip_graffiti.h"
#include "flip_graffiti_rcp.h"

#ifdef RAW_TO_SCREEN
#define ORIG_TRAP_ID TRAP1_ID
#else
#define ORIG_TRAP_ID TRAP2_ID
#endif

static void flip_pen(PointType *pen, int left, int right, int top, int bottom)
{
    FlipAngleT angle = kFlipNoAngle;
    int x, y;

    GetAngle(&angle);

    if (angle > kFlip0Deg && angle < kFlipNumAngles) {
	x = pen->x - left;
	y = pen->y - top;

	switch (angle) {
	case kFlip90Deg:
#ifdef RAW_TO_SCREEN
	    pen->x = left + y;
	    pen->y = bottom - x;
#else
	    pen->x = right - y;
	    pen->y = top + x;
#endif
	    break;

	case kFlip180Deg:
	    pen->x = right - x;
	    pen->y = bottom - y;
	    break;

	case kFlip270Deg:
#ifdef RAW_TO_SCREEN
	    pen->x = right - y;
	    pen->y = top + x;
#else
	    pen->x = left + y;
	    pen->y = bottom - x;
#endif
	    break;

	default:
	    break;
	}
    }
}

Err MyHandler(PointType *pen)
{
    Err (*orig_trap)(PointType *pen);
    Err err;

    err = FtrGet(CREATOR, ORIG_TRAP_ID, (DWord *) &orig_trap);
    if (err == noErr) {
#ifdef RAW_TO_SCREEN
	err = (*orig_trap)(pen);
#endif

	if (pen->x >= ABC_LEFT && pen->x < ABC_RIGHT
	 && pen->y >= ABC_TOP && pen->y < ABC_BOTTOM) {
	    flip_pen(pen, ABC_LEFT, ABC_RIGHT, ABC_TOP, ABC_BOTTOM);
	}

	if (pen->x >= NUM_LEFT && pen->x < NUM_RIGHT
	 && pen->y >= NUM_TOP && pen->y < NUM_BOTTOM) {
	    flip_pen(pen, NUM_LEFT, NUM_RIGHT, NUM_TOP, NUM_BOTTOM);
	}

#ifdef SCREEN_TO_RAW
	err = (*orig_trap)(pen);
#endif
    }

    return err;
}
